class Public::MedicalReleasesController < Public::BaseController
  before_action :set_account, :set_project, :set_contract_template

  def new
    @medical_release = build_medical_release
  end

  def create
    @medical_release = build_medical_release(medical_release_params_with_locale_and_contract_template)

    if @medical_release.save(context: :native)
      if @medical_release.contract_template.present?
        AttachContractToReleasableJob.perform_later(@medical_release)
      end
      log_create_analytics
    else
      render :new
    end
  end

  private

  def set_project
    @project = @account.projects.find(params[:project_id])
  end

  def set_account
    @account = Account.find_by(slug: params[:account_id])
  end

  def set_contract_template
    @contract_template = @project.contract_templates.find(params[:contract_template_id])
  end

  def medical_releases
    policy_scope(@project.medical_releases)
  end

  def build_medical_release(params = {})
    authorize medical_releases.build(params)
  end

  def medical_release_params
    params
      .require(:medical_release)
      .permit(
        person_params,
        :signature_base64,
        :locale,
        :contract_template,
        :question_1_answer, :question_2_answer,
        :question_3_answer, :question_4_answer,
        :question_5_answer, :question_6_answer,
        :question_7_answer, :question_8_answer,
        :question_9_answer, :question_10_answer,
        photos: [],
      )
  end

  def person_params
    [
      :person_first_name,
      :person_last_name,
      :person_phone,
      :person_email,
      :person_address_street1,
      :person_address_street2,
      :person_address_city,
      :person_address_state,
      :person_address_zip,
      :person_address_country,
    ]
  end

  def medical_release_params_with_locale
    medical_release_params.merge(locale: I18n.locale)
  end

  def medical_release_params_with_locale_and_contract_template
    medical_release_params_with_locale.merge(contract_template: @contract_template)
  end

  def log_create_analytics
    TrackAnalyticsJob.perform_later(nil, nil, :track_create_native_release, release_type: MedicalRelease.to_s, account: @account, user_agent: request.user_agent, user_ip: request.remote_ip)
  end
end
